
prepare_outputs <- function(recipe) {

# recipe: the content of the readed recipe
# file: the recipe file name

  output_dir = recipe$Run$output_dir
  # Create output folders:
  folder_name <- paste0(gsub(".yml", "", gsub("/", "_", recipe$filename)), "_",
                        gsub(" ", "", gsub(":", "", gsub("-", "", Sys.time()))))
  print(folder_name)

  dir.create(file.path(output_dir, folder_name, 'plots'), recursive = TRUE)
  dir.create(file.path(output_dir, folder_name, 'outputs'))
  dir.create(file.path(output_dir, folder_name, 'logs'))
  dir.create(file.path(output_dir, folder_name, 'logs', 'recipes'))

  file.copy(recipe$filename, file.path(output_dir, folder_name, 'logs'))

  logfile <- file.path(output_dir, folder_name, 'logs', 'log.txt')

  # Set default behaviour of log output file:
  if (is.null(recipe$Run)) {
    recipe$Run <- list(Loglevel = 'INFO', Terminal = TRUE)
  }
  if (is.null(recipe$Run$Loglevel)) { 
    recipe$Run$Loglevel <- 'INFO'
  }
  if (!is.logical(recipe$Run$Terminal)) {
    recipe$Run$Terminal <- TRUE
  }
  if (recipe$Run$Terminal) {
    logger <- logger(threshold = recipe$Run$Loglevel,  
              appenders = list(console_appender(layout = default_log_layout()),
                               file_appender(logfile, append = TRUE,   
                               layout = default_log_layout())))
  } else {
    logger <- logger(threshold = recipe$Run$Loglevel,
                appenders = list(file_appender(logfile, append = TRUE,             
                               layout = default_log_layout())))
  }
  return(list(logger = logger, logname = logfile,
              foldername = file.path(output_dir, folder_name)))
}
